unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Cards, ExtCtrls, StdCtrls, Menus, ComCtrls, Param, Buttons, Registry;

type
  TSoliterForm = class(TForm)
    Timer: TTimer;
    MainMenu: TMainMenu;
    Game: TMenuItem;
    HelpMenu: TMenuItem;
    StatusBar: TStatusBar;
    NewGame_F2: TMenuItem;
    AgainGame_F3: TMenuItem;
    line1: TMenuItem;
    Param: TMenuItem;
    CancelHOD: TMenuItem;
    line2: TMenuItem;
    Exit: TMenuItem;
    Help: TMenuItem;
    line: TMenuItem;
    About: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure NewGame_F2Click(Sender: TObject);
    procedure CancelHODClick(Sender: TObject);
    procedure AgainGame_F3Click(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HelpClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ParamClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    SoliterGame: TSoliter;
    procedure SetEnable;
    procedure WMEXITSIZEMOVE(var message: TMessage); message WM_EXITSIZEMOVE;
    procedure WMSYSCOMMAND(var msg: TWmSysCommand); message WM_SYSCOMMAND;
    { Public declarations }
  end;

var
  SoliterForm: TSoliterForm;

implementation

{$R *.dfm}

procedure TSoliterForm.SetEnable;
begin
  AgainGame_F3.Enabled := SoliterGame.CanUndo;
  Help.Enabled := SoliterGame.GetCountMoves > 0;
  CancelHOD.Enabled := AgainGame_F3.Enabled;
end;

procedure TSoliterForm.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True; //       !!!
  SoliterGame := TSoliter.Create(Self);
  SoliterGame.Parent := Self;
  SoliterGame.LoadParamFromIniFile;
  SetEnable;
end;

procedure TSoliterForm.TimerTimer(Sender: TObject);
begin
  SoliterGame.NextStep;
  StatusBar.SimpleText := SoliterGame.GetText;
  SetEnable;
end;

procedure TSoliterForm.NewGame_F2Click(Sender: TObject);
begin
  if (not SoliterGame.CanUndo) or
     (Application.MessageBox('  ?', '', MB_YESNO or MB_ICONQUESTION) = IDYES) then
      SoliterGame.NewGame(True);
end;

procedure TSoliterForm.AgainGame_F3Click(Sender: TObject);
begin
  if (not SoliterGame.CanUndo) or
     (Application.MessageBox(' ?', '', MB_YESNO or MB_ICONQUESTION) = IDYES) then
      SoliterGame.NewGame(False);
end;

procedure TSoliterForm.CancelHODClick(Sender: TObject);
begin
  SoliterGame.DoUndo;
end;

procedure TSoliterForm.ExitClick(Sender: TObject);
begin
  SoliterForm.Close;
end;

procedure TSoliterForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := (not SoliterGame.CanUndo) or
              (Application.MessageBox(' ?', '', MB_YESNO or MB_ICONQUESTION) = IDYES);
end;

procedure TSoliterForm.HelpClick(Sender: TObject);
begin
  SoliterGame.ShowVariantHoda;
end;

procedure TSoliterForm.FormDestroy(Sender: TObject);
begin
  SoliterGame.SaveParamToIniFile;
  SoliterGame.Free;
end;

procedure TSoliterForm.ParamClick(Sender: TObject);
begin
  ParamForm := TParamForm.Create(self);
  if ParamForm.ShowModal = mrOk then
    begin
      SoliterGame.SaveParamToIniFile;
      SoliterGame.ChangeConturColor;
      SoliterGame.DrawGame;
    end;
  ParamForm.Free;  
end;

procedure TSoliterForm.WMEXITSIZEMOVE(var message: TMessage); //    
begin
  SoliterGame.RecalcNewSizeGame;
  inherited;
end;

procedure TSoliterForm.WMSYSCOMMAND(var msg: TWmSysCommand); 
begin
  inherited;
  case (msg.CmdType and $FFF0) of
    SC_MINIMIZE: ;
    SC_RESTORE : SoliterGame.RecalcNewSizeGame;
    SC_MAXIMIZE: SoliterGame.RecalcNewSizeGame;
  end;
end;

procedure TSoliterForm.FormResize(Sender: TObject);
begin
  SoliterGame.RecalcNewSizeGame;
  OnResize := nil;
end;

procedure TSoliterForm.FormShow(Sender: TObject);
begin
  OnResize := FormResize;
end;

end.
