unit Param;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Cards, StdCtrls, Spin;

type
  TParamForm = class(TForm)
    Image: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ColorDialog: TColorDialog;
    SpinEdit: TSpinEdit;
    Label1: TLabel;
    CheckBox: TCheckBox;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    CurrentFonColor, CurrentCol1, CurrentCol2: TColor;
    procedure DrawPict;
  public
    { Public declarations }
  end;

var
  ParamForm: TParamForm;

implementation

{$R *.dfm}

uses Main;

procedure TParamForm.DrawPict;
var
  TempBM: TBitmap;
begin
  TempBM := TBitmap.Create;
  TempBM.LoadFromFile(APPLICATION_PATH + '\pic\SMALL_FON.bmp');
  TransformBitMap(CurrentFonColor, TempBM);  
  Image.Canvas.Draw(0,0, TempBM);
  TempBM.LoadFromFile(APPLICATION_PATH + '\pic\CARDS_ON_SMALL_FON.bmp');
  TempBM.Transparent := True;
  Image.Canvas.Draw(0,0, TempBM);  
  DrawOreolRect(Image.Canvas, 14, 128, 57, 204, CurrentCol1);
  DrawOreolRect(Image.Canvas, 222, 128, 265, 186, CurrentCol2);  
  TempBM.Free;
end;

procedure TParamForm.Button1Click(Sender: TObject);
begin
  ColorDialog.Color := CurrentFonColor;
  if ColorDialog.Execute then
    begin
      CurrentFonColor := ColorDialog.Color;
      DrawPict;
    end;
end;

procedure TParamForm.Button2Click(Sender: TObject);
begin
  ColorDialog.Color := CurrentCol1;
  if ColorDialog.Execute then
    begin
      CurrentCol1 := ColorDialog.Color;
      DrawPict;
    end;
end;

procedure TParamForm.Button3Click(Sender: TObject);
begin
  ColorDialog.Color := CurrentCol2;
  if ColorDialog.Execute then
    begin
      CurrentCol2 := ColorDialog.Color;
      DrawPict;
    end;
end;

procedure TParamForm.Button4Click(Sender: TObject);
begin
  if CurrentFonColor <> FON_COLOR then
    begin
      FON_COLOR := CurrentFonColor;
      SoliterForm.SoliterGame.RecalcNewSizeGame;
    end;
  ModalResult := mrOk;
  COLOR_FROM := CurrentCol1;
  COLOR_AIM := CurrentCol2; 
  SPEED_CARD := SpinEdit.Value;
  NEED_SHOW_FREE_CELL := CheckBox.Checked;
end;

procedure TParamForm.Button5Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TParamForm.FormShow(Sender: TObject);
begin
  CurrentFonColor := FON_COLOR;
  CurrentCol1 := COLOR_FROM;
  CurrentCol2 := COLOR_AIM;
  SpinEdit.Value := SPEED_CARD;
  CheckBox.Checked := NEED_SHOW_FREE_CELL;
  DrawPict;
end;

end.
